package com.burtbeckwith.mvctest.service

import com.burtbeckwith.mvctest.domain.Book

class BookService implements IBookService {

	boolean transactional = false

	/**
	 * {@inheritDoc}
	 * @see com.burtbeckwith.mvctest.service.IBookService#getAllBooks()
	 */
	List<Book> getAllBooks() {
		return Book.list()
	}

	/**
	 * {@inheritDoc}
	 * @see com.burtbeckwith.mvctest.service.IBookService#getBook(long)
	 */
	Book getBook(long id) {
		return Book.get(id)
	}
}
