grails.mime.file.extensions = true
grails.mime.types = [html: ['text/html','application/xhtml+xml'],
                     xml: ['text/xml', 'application/xml'],
                     text: 'text-plain',
                     js: 'text/javascript',
                     rss: 'application/rss+xml',
                     atom: 'application/atom+xml',
                     css: 'text/css',
                     csv: 'text/csv',
                     all: '*/*',
                     json: ['application/json','text/json'],
                     form: 'application/x-www-form-urlencoded',
                     multipartForm: 'multipart/form-data']
grails.views.default.codec = "none"
grails.views.gsp.encoding = "UTF-8"
grails.converters.encoding = "UTF-8"

grails.enable.native2ascii = true

environments {
	production {
		grails.serverURL = "http://www.changeme.com"
	}
}

log4j {
	appender.stdout = "org.apache.log4j.ConsoleAppender"
	appender.'stdout.layout' = "org.apache.log4j.PatternLayout"
	appender.'stdout.layout.ConversionPattern' = '[%r] %c{2} %m%n'
	appender.stacktraceLog = "org.apache.log4j.FileAppender"
	appender.'stacktraceLog.layout' = "org.apache.log4j.PatternLayout"
	appender.'stacktraceLog.layout.ConversionPattern' = '[%r] %c{2} %m%n'
	appender.'stacktraceLog.File' = "stacktrace.log"
	rootLogger = "error,stdout"
	logger {
		grails = "error"
		StackTrace = "error,stacktraceLog"
		org {
			codehaus.groovy.grails.web.servlet = "error"
			codehaus.groovy.grails.web.pages = "error"
			codehaus.groovy.grails.web.sitemesh = "error"
			codehaus.groovy.grails."web.mapping.filter" = "error"
			codehaus.groovy.grails."web.mapping" = "error"
			codehaus.groovy.grails.commons = "info"
			codehaus.groovy.grails.plugins = "error"
			codehaus.groovy.grails.orm.hibernate = "error"
			springframework = "off"
			hibernate = "off"
		}
		com.burtbeckwith = 'debug'
	}
	additivity.StackTrace = false
}

// Spring MVC plugin
springmvc {
	interceptors = ['loggingInterceptor']
	urlSuffix = 'action'
}
