dataSource {
	pooled = true
	driverClassName = 'org.hsqldb.jdbcDriver'
	username = 'sa'
	password = ''
}
hibernate {
	cache.use_second_level_cache = true
	cache.use_query_cache = true
	cache.provider_class = 'org.hibernate.cache.EhCacheProvider'
}

environments {
	development {
		dataSource {
			dbCreate = 'create-drop'
			url = 'jdbc:hsqldb:mem:devDB'
		}
	}
	test {
		dataSource {
			dbCreate = 'update'
			url = 'jdbc:hsqldb:mem:testDb'
		}
	}
	production {
		dataSource {
			dbCreate = 'create-drop'
			url = 'jdbc:hsqldb:mem:prodDB'
		}
	}
}
